; ============================================================
; == Routines pour la gestion des paramtres de l'afficheur ==
; ==                                                        ==
; ==   - Encodeur -> Navigation dans les options            ==
; ==   - Menu     -> Entrer dans une option                 ==
; ==   - StandBy  -> Remonter au menu prcdent sans sauver ==
; ==                                                        ==
; ============================================================

MenuDisplay:

WaitMenuDisplay:
		sbis	PinMenu,SwitchMenu					; Avant de passer  la suite,
		rjmp	WaitMenuDisplay						; On attend le relachement du bouton de menu

; OK, on a lch le bouton

		ldi		Work,0								; Dbut de premire ligne
		call	DisplayPlaceCurseur
		ldi		ZH,HIGH(MenuDisplayTopMessage*2)
		ldi		ZL,LOW(MenuDisplayTopMessage*2)
		call	DisplayAfficheChaine

		ldi		Work,0x40							; on se place
		call	DisplayPlaceCurseur					; sur la seconde ligne de l'afficheur
		ldi		ZH,HIGH(MenuDisplayBrightMessage*2)
		ldi		ZL,LOW(MenuDisplayBrightMessage*2)
		call	DisplayAfficheChaine				; affiche le "message" de l'encodeur 
		call	DisplayArrow						; et les flches de l'encodeur

		clr		MenuReg1

LoopLevelD0:

		call 	LectureEncodeur						; Lecture de l'encodeur
		sbrs	StatReg1,FlagIncremente				; doit-on incrmenter
		sbrc	StatReg1,FlagDecremente				; ou dcrmenter ?
		rjmp	ChangeDisplayMenu					; l'un des deux...

		sbis	PinSwitchMC,SwitchMC				; Un appui sur l'annulation pour sortir ?
		rjmp	ExitDisplayMenu						; Oui, alors on y va

		sbic	PinMenu,SwitchMenu					; Un appui sur Menu ?
		rjmp 	LoopLevelD0							; Non, on boucle

		call	Attendre							; On attend un peu...
		sbic	PinMenu,SwitchMenu					; Menu  toujours appuy ?
		rjmp 	LoopLevelD0							; Non, on boucle

		rjmp	WhatDisplayMenuToEnter				; sinon on entre dans le menu de config qu'il faut
			
ChangeDisplayMenu:

		sbrc	StatReg1,FlagIncremente				; regarde dans quel sens allait l'encodeur
		rjmp	IncDispMenuReg1						; Vers le haut ?
		sbrc	StatReg1,FlagDecremente				; 
		rjmp	DecDispMenuReg1						; vers le bas ?
		rjmp	LoopLevelD0							; Aucun des deux, alors cassos

IncDispMenuReg1:									; Incrmentation du numro de menu
		mov		Work,MenuReg1						; transfert dans un registre immdiat
		cpi		Work,4								; c'est le dernier menu ?
		brne	DoIncDispMR1						; non, alors on peut incrmenter sans pb

		clr		MenuReg1							; sinon, on le repasse  0		
		rjmp	AfficheMenuDisp0					; et on va afficher la chaine qu'il faut
DoIncDispMR1:
		inc		MenuReg1							; On incrmente le registre
#if defined(VFD)
		ldi		Work,1								; Vrifie dans le cas du VFD que l'on ne vas pas toucher au contraste 
		cp		Work,MenuReg1
		brne	AfficheMenuDisp0
		inc 	MenuReg1
#endif
		rjmp	AfficheMenuDisp0					; et on va afficher la chaine qu'il faut

DecDispMenuReg1:									; Dcrmentation du numro de menu
		mov		Work,MenuReg1						; transfert dans un registre immdiat
		cpi		Work,0								; c'est le dernier menu ?
		brne	DoDecDispMR1						; non, alors on peut dcrmenter sans pb

		ldi		Work,4
		mov		MenuReg1,Work						; sinon, on le repasse  4		
		rjmp	AfficheMenuDisp0					; et on va afficher la chaine qu'il faut
DoDecDispMR1:
		dec		MenuReg1							; On dcrmente le registre
#if defined(VFD)
		ldi		Work,1								; Vrifie dans le cas du VFD que l'on ne vas pas toucher au contraste 
		cp		Work,MenuReg1
		brne	AfficheMenuDisp0
		dec 	MenuReg1
#endif

AfficheMenuDisp0:									; affiche le menu correspondant au contenu de MenuReg1 (entre 0 et 4)

		cbr		StatReg1,EXP2(FlagIncremente)		; On commence par remettre  0 les flags de l'encodeur
		cbr		StatReg1,EXP2(FlagDecremente)

		ldi		Work,0x40							; On se place en dbut de seconde ligne
		call	DisplayPlaceCurseur

		mov		Work,MenuReg1						; On met le registre dans un registre immdiat

TestMenuDispBright:

		cpi		Work,0								; C'est 0 ?
		brne	TestMenuDispContrast				; Nan...

		ldi		ZH,HIGH(MenuDisplayBrightMessage*2)	; Oui, c'est 0
		ldi		ZL,LOW(MenuDisplayBrightMessage*2)
		call	DisplayAfficheChaine				; Affiche la premire chaine de setup
		call	DisplayArrow						; et les flches de l'encodeur
		rjmp	LoopLevelD0							; et on continue la boucle

TestMenuDispContrast:

		cpi		Work,1								; C'est 1 ?
		brne	TestMenuIdleBright					; Nan...

		ldi		ZH,HIGH(MenuDisplayContrastMessage*2); Oui, c'est 1
		ldi		ZL,LOW(MenuDisplayContrastMessage*2)
		call	DisplayAfficheChaine				; Affiche la premire chaine de setup
		call	DisplayArrow						; et les flches de l'encodeur
		rjmp	LoopLevelD0							; et on continue la boucle

TestMenuIdleBright:

		cpi		Work,2								; C'est 2 ?
		brne	TestMenuIdleTimeOut					; Nan...

		ldi		ZH,HIGH(MenuDisplayIdleBrightMessage*2); Oui
		ldi		ZL,LOW(MenuDisplayIdleBrightMessage*2)
		call	DisplayAfficheChaine				; Affiche la premire chaine de setup
		call	DisplayArrow						; et les flches de l'encodeur
		rjmp	LoopLevelD0							; et on continue la boucle

TestMenuIdleTimeOut:

		cpi		Work,3								; C'est 3 ?
		brne	TestMenuIdleLed						; Nan...

		ldi		ZH,HIGH(MenuDisplayIdleTimeOutMessage*2); Yes
		ldi		ZL,LOW(MenuDisplayIdleTimeOutMessage*2)
		call	DisplayAfficheChaine				; Affiche la premire chaine de setup
		call	DisplayArrow						; et les flches de l'encodeur
		rjmp	LoopLevelD0							; et on continue la boucle

TestMenuIdleLed:

		ldi		ZH,HIGH(MenuDisplayIdleLedMessage*2); Yes
		ldi		ZL,LOW(MenuDisplayIdleLedMessage*2)
		call	DisplayAfficheChaine				; Affiche la premire chaine de setup
		call	DisplayArrow						; et les flches de l'encodeur
		rjmp	LoopLevelD0							; et on continue la boucle

WhatDisplayMenuToEnter:

		mov		Work,MenuReg1						; Transfert en immdiat
		cpi		Work,0								; si c'est 0
		breq	EnterMenuDisplayBrightness			; on va triturer le menu de la luminosit
		cpi		Work,1								; si c'est 1
		breq	EnterMenuDisplayContrast			; on va triturer le menu du contraste
		cpi		Work,2								; si c'est 2
		breq	EnterMenuDisplayIdleBright			; on va triturer le menu de la luminosit d'Idle
		cpi		Work,3								; si c'est 3
		breq	EnterMenuDisplayIdleTimeOut			; on va triturer le menu de la dure du Timeout
		rjmp	EnterMenuDisplayIdleLed				; Sinon, c'est 4 et on va triturer le menu de l'extinction de la led


EnterMenuDisplayBrightness:							; on va triturer le menu de la luminosit

		call 	Attendre							; On attend un peu
		sbic	PinMenu,SwitchMenu					; Un vrai appui sur le bouton de menu ?
		rjmp	TestMenuDispBright					; Sinon,on revient au bon endroit

		ldi		Work,0								; Valeur  0 -> Luminosit
		mov		MenuReg2,Work
		rcall	MenuAjusteDisplayB					; On y va

		ldi		Work,0								; Pour le retour -> Dbut de premire ligne
		call	DisplayPlaceCurseur
		ldi		ZH,HIGH(MenuDisplayTopMessage*2)
		ldi		ZL,LOW(MenuDisplayTopMessage*2)
		call	DisplayAfficheChaine

		ldi		Work,0x40							; on se place
		call	DisplayPlaceCurseur					; sur la seconde ligne de l'afficheur

		clr		Work
		mov		MenuReg1,Work						; On remet la bonne valeur dans MenuReg1
		rjmp	TestMenuDispBright					; et on revient au bon endroit

EnterMenuDisplayContrast:							; on va triturer le menu du contraste

		call 	Attendre							; On attend un peu
		sbic	PinMenu,SwitchMenu					; Un vrai appui sur le bouton de menu ?
		rjmp	TestMenuDispContrast				; Sinon,on revient au bon endroit

		ldi		Work,1								; Valeur  1 -> Contraste
		mov		MenuReg2,Work
		rcall	MenuAjusteDisplayC					; On y va

		ldi		Work,0								; Pour le retour -> Dbut de premire ligne
		call	DisplayPlaceCurseur
		ldi		ZH,HIGH(MenuDisplayTopMessage*2)
		ldi		ZL,LOW(MenuDisplayTopMessage*2)
		call	DisplayAfficheChaine

		ldi		Work,0x40							; on se place
		call	DisplayPlaceCurseur					; sur la seconde ligne de l'afficheur

		ldi		Work,1
		mov		MenuReg1,Work						; On remet la bonne valeur dans MenuReg1
		rjmp	TestMenuDispContrast				; et on revient au bon endroit

EnterMenuDisplayIdleBright:							; on va triturer le menu de la luminosit d'Idle

		call 	Attendre							; On attend un peu
		sbic	PinMenu,SwitchMenu					; Un vrai appui sur le bouton de menu ?
		rjmp	TestMenuIdleBright					; Sinon,on revient au bon endroit

		ldi		Work,2								; Valeur  2 -> Luminosit Idle
		mov		MenuReg2,Work
		rcall	MenuAjusteDisplayI					; On y va

		ldi		Work,0								; Pour le retour -> Dbut de premire ligne
		call	DisplayPlaceCurseur
		ldi		ZH,HIGH(MenuDisplayTopMessage*2)
		ldi		ZL,LOW(MenuDisplayTopMessage*2)
		call	DisplayAfficheChaine

		ldi		Work,0x40							; on se place
		call	DisplayPlaceCurseur					; sur la seconde ligne de l'afficheur

		ldi		Work,2
		mov		MenuReg1,Work						; On remet la bonne valeur dans MenuReg1
		rjmp	TestMenuIdleBright					; et on revient au bon endroit

EnterMenuDisplayIdleTimeOut:						; on va triturer le menu de la dure avant passage en mode Idle

		call 	Attendre							; On attend un peu
		sbic	PinMenu,SwitchMenu					; Un vrai appui sur le bouton de menu ?
		rjmp	TestMenuIdleBright					; Sinon,on revient au bon endroit

		ldi		Work,3								; Valeur  3 -> Dure avant Idle
		mov		MenuReg2,Work
		rcall	MenuAjusteDisplayT					; On y va

		ldi		Work,0								; Pour le retour -> Dbut de premire ligne
		call	DisplayPlaceCurseur
		ldi		ZH,HIGH(MenuDisplayTopMessage*2)
		ldi		ZL,LOW(MenuDisplayTopMessage*2)
		call	DisplayAfficheChaine

		ldi		Work,0x40							; on se place
		call	DisplayPlaceCurseur					; sur la seconde ligne de l'afficheur

		ldi		Work,3
		mov		MenuReg1,Work						; On remet la bonne valeur dans MenuReg1
		rjmp	TestMenuIdleTimeOut					; et on revient au bon endroit

EnterMenuDisplayIdleLed:							; on va triturer le menu de la Led en Idle

		call 	Attendre							; On attend un peu
		sbic	PinMenu,SwitchMenu					; Un vrai appui sur le bouton de menu ?
		rjmp	TestMenuIdleBright					; Sinon,on revient au bon endroit

		ldi		Work,4								; Valeur  4 -> Luminosit Led
		mov		MenuReg2,Work
		rcall	MenuAjusteDisplayL					; On y va

		ldi		Work,0								; Pour le retour -> Dbut de premire ligne
		call	DisplayPlaceCurseur
		ldi		ZH,HIGH(MenuDisplayTopMessage*2)
		ldi		ZL,LOW(MenuDisplayTopMessage*2)
		call	DisplayAfficheChaine

		ldi		Work,0x40							; on se place
		call	DisplayPlaceCurseur					; sur la seconde ligne de l'afficheur

		ldi		Work,4
		mov		MenuReg1,Work						; On remet la bonne valeur dans MenuReg1
		rjmp	TestMenuIdleBright					; et on revient au bon endroit

ExitDisplayMenu:
		call 	Attendre							; On attend pour le dbounce
		sbic	PinSwitchMC,SwitchMC				; C'est un vrai appui sur l'annulation pour sortir ?
		rjmp	LoopLevelD0							; Non, fausse arlette et on replonge dans la boucle

WaitBeforeExitDisplayMenu:
		sbis	PinSwitchMC,SwitchMC				; petit test habituel pour ne pas effectuer
		rjmp	WaitBeforeExitDisplayMenu			; des sorties de menu en cascade

		ret											; on se casse de ce menu

; ============================================================
; == Rglage de la luminosit de l'afficheur                ==
; ==                                                        ==
; ==   - Encodeur -> Changer la valeur                      ==
; ==   - Menu     -> Valider la nouvelle valeur             ==
; ==   - StandBy  -> Remonter au menu prcdent sans sauver ==
; ============================================================

MenuAjusteDisplayB:

WaitMenuAjusteDisplayB:
		sbis	PinMenu,SwitchMenu					; Avant de passer  la suite,
		rjmp	WaitMenuAjusteDisplayB				; On attend le relachement du bouton de menu

; Bouton relch, on continue

		ldi		Work,0								; Se place au dbut
		call	DisplayPlaceCurseur

		ldi		ZH,HIGH(MenuDisplayBrightTopMessage*2)
		ldi		ZL,LOW(MenuDisplayBrightTopMessage*2)
		call	DisplayAfficheChaine

; On rcupre la valeur de la luminosit en RAM

		ldi		ZH,RAM_Start						; Octet de poids fort de l'adresse de dbut en RAM 
		ldi		ZL,RAM_StartBrightness				; L'adresse de ce paramtre en RAM

		ld		MenuReg1,Z							; Rcupre la valeur stocke en RAM dans MenuReg1

		rcall	AfficheBrightnessOrContrast			; En seconde ligne

LoopLevelDispAdj0B:

		call 	LectureEncodeur						; Lecture de l'encodeur
		sbrs	StatReg1,FlagIncremente				; doit-on incrmenter
		sbrc	StatReg1,FlagDecremente				; ou dcrmenter ?
		rjmp	MenuChangeB							; l'un des deux...

		sbis	PinSwitchMC,SwitchMC				; Un appui sur l'annulation pour sortir sans sauver ?
		rjmp	ExitAjusteDisplayBMenuNoSave		; Oui, alors on y va

		sbic	PinMenu,SwitchMenu					; Un appui sur Menu ?
		rjmp 	LoopLevelDispAdj0B					; Non, on boucle

		rjmp	ExitAjusteDisplayBMenu				; sinon on se sauve en sauvant

MenuChangeB:

		sbrc	StatReg1,FlagIncremente				; regarde dans quel sens allait l'encodeur
		rjmp	IncBMenuReg1						; Vers le haut ?
		sbrc	StatReg1,FlagDecremente				; 
		rjmp	DecBMenuReg1						; vers le bas ?
		rjmp	LoopLevelDispAdj0B					; Aucun des deux, alors cassos

IncBMenuReg1:										; Incrmentation du paramtre
		mov		Work,MenuReg1
		cpi		Work,BrightnessMax					; c'est le max ?
		brne	DoIncBMR1							; non, alors on peut incrmenter sans pb

		rjmp	LoopLevelDispAdj0B					; Sinon, on ne fait rien

DoIncBMR1:
		inc		MenuReg1							; On incrmente le registre
		rjmp	MenuActualiseB						; et on modifie la luminosit

DecBMenuReg1:										; Dcrmentation de la luminosit
		mov		Work,MenuReg1						; transfert dans un registre immdiat
		cpi		Work,0								; c'est le min ?
		brne	DoDecBMR1							; non, alors on peut dcrmenter sans pb

		rjmp	LoopLevelDispAdj0B					; Sinon, on ne fait rien

DoDecBMR1:
		dec		MenuReg1							; On dcrmente le registre
		rjmp	MenuActualiseB						; et on modifier la luminosit

MenuActualiseB:										; On modifie vraiment la luminosit

		lds		Work,TCCR3B							; si le timer 3 ne tourne pas
		andi	Work,0b00000111						; on lance le clignotement de la LED On
		cpi		Work,0								; car on a modifi la valeur qui tait stocke
		brne	DoMenuActualiseB						
		call	LanceClignotementLED

DoMenuActualiseB:
		cbr		StatReg1,EXP2(FlagIncremente)		; On commence par remettre  0 les flags de l'encodeur
		cbr		StatReg1,EXP2(FlagDecremente)

		mov		Work,MenuReg1						; On transfre le paramtre dans le bon regsitre

		call	SetBrightness						;
		rcall	AfficheBrightnessOrContrast			; et affiche la valeur
		rjmp	LoopLevelDispAdj0B					; Boucle Again

ExitAjusteDisplayBMenuNoSave:						; On se sauve sans sauver...

		sbis	PinSwitchMC,SwitchMC				; petit test habituel pour ne pas effectuer
		rjmp	ExitAjusteDisplayBMenuNoSave		; des sorties de menu en cascade

		call	ArreteClignotementLED				; Au cazo, on rallume la LED de On/StandBy

		ldi		ZH,RAM_Start						; Octet de poids fort de l'adresse de dbut en RAM 
		ldi		ZL,RAM_StartBrightness				; L'adresse de ce paramtre en RAM
		ld		Work,Z							 	; Rcupre la valeur stocke en RAM
		call	SetBrightness
		ret

ExitAjusteDisplayBMenu:
		sbis	PinMenu,SwitchMenu					; petit test habituel pour ne pas effectuer
		rjmp	ExitAjusteDisplayBMenu				; des sorties de menu en cascade

		call	ArreteClignotementLED				; Au cazo, on rallume la LED de On/StandBy

		ldi		Work,SaveLong						; Fixe le temps d'affichage du prochain message
		call	AfficheSaving						; Affiche le message de sauvegarde

		ldi		ZH,RAM_Start						; Octet de poids fort de l'adresse de dbut en RAM 
		ldi		ZL,RAM_StartBrightness				; L'adresse de ce paramtre en RAM
		st		Z,MenuReg1							; et enregistre la valeur en RAM

		mov		Work2,MenuReg1						; La donne  enregistrer en EEPROM
		ldi		Work,EE_StartBrightness				; et son adresse					
		call	WriteEEprom							; on enregistre

		ret											; et cassos


; ============================================================
; == Rglage du contraste de l'afficheur                    ==
; ==                                                        ==
; ==   - Encodeur -> Changer la valeur                      ==
; ==   - Menu     -> Valider la nouvelle valeur             ==
; ==   - StandBy  -> Remonter au menu prcdent sans sauver ==
; ============================================================

MenuAjusteDisplayC:

#if defined(LCD)

WaitMenuAjusteDisplayC:
		sbis	PinMenu,SwitchMenu					; Avant de passer  la suite,
		rjmp	WaitMenuAjusteDisplayC				; On attend le relachement du bouton de menu

; Bouton relch, on continue

		ldi		Work,0								; Se place au dbut
		call	DisplayPlaceCurseur

		ldi		ZH,HIGH(MenuDisplayContrastTopMessage*2)
		ldi		ZL,LOW(MenuDisplayContrastTopMessage*2)
		call	DisplayAfficheChaine

; On rcupre la valeur du contraste en RAM

		ldi		ZH,RAM_Start						; Octet de poids fort de l'adresse de dbut en RAM 
		ldi		ZL,RAM_StartContrast				; L'adresse de ce paramtre en RAM

		ld		MenuReg1,Z							; Rcupre la valeur stocke en RAM dans MenuReg1

		rcall	AfficheBrightnessOrContrast			; En seconde ligne

LoopLevelDispAdj0C:

		call 	LectureEncodeur						; Lecture de l'encodeur
		sbrs	StatReg1,FlagIncremente				; doit-on incrmenter
		sbrc	StatReg1,FlagDecremente				; ou dcrmenter ?
		rjmp	MenuChangeC							; l'un des deux...

		sbis	PinSwitchMC,SwitchMC				; Un appui sur le bouton d'annulation pour sortir sans sauver ?
		rjmp	ExitAjusteDisplayCMenuNoSave		; Oui, alors on y va

		sbic	PinMenu,SwitchMenu					; Un appui sur Menu ?
		rjmp 	LoopLevelDispAdj0C					; Non, on boucle

;		call	Attendre							; On attend un peu...
;		sbic	PinMenu,SwitchMenu					; Menu  toujours appuy ?
;		rjmp 	LoopLevelDispAdj0C					; Non, on boucle

		rjmp	ExitAjusteDisplayCMenu				; sinon on se sauve en sauvant


MenuChangeC:

		sbrc	StatReg1,FlagIncremente				; regarde dans quel sens allait l'encodeur
		rjmp	IncCMenuReg1						; Vers le haut ?
		sbrc	StatReg1,FlagDecremente				; 
		rjmp	DecCMenuReg1						; vers le bas ?
		rjmp	LoopLevelDispAdj0C					; Aucun des deux, alors cassos

IncCMenuReg1:										; Incrmentation du paramtre
		mov		Work,MenuReg1
		cpi		Work,ContrasteMaxi					; c'est le max ?
		brne	DoIncCMR1							; non, alors on peut incrmenter sans pb

		rjmp	LoopLevelDispAdj0C					; Sinon, on ne fait rien

DoIncCMR1:
		inc		MenuReg1							; On incrmente le registre
		rjmp	MenuActualiseC						; et on modifie le contraste

DecCMenuReg1:										; Dcrmentation ddu contraste
		mov		Work,MenuReg1						; transfert dans un registre immdiat
		cpi		Work,0								; c'est le min ?
		brne	DoDecCMR1							; non, alors on peut dcrmenter sans pb

		rjmp	LoopLevelDispAdj0C					; Sinon, on ne fait rien

DoDecCMR1:
		dec		MenuReg1							; On dcrmente le registre
		rjmp	MenuActualiseC						; et on modifier la luminosit

MenuActualiseC:										; On modifie vraiment la luminosit

		lds		Work,TCCR3B							; si le timer 3 ne tourne pas
		andi	Work,0b00000111						; on lance le clignotement de la LED On
		cpi		Work,0								; car on a modifi la valeur qui tait stocke
		brne	DoMenuActualiseC						
		call	LanceClignotementLED

DoMenuActualiseC:
		cbr		StatReg1,EXP2(FlagIncremente)		; On commence par remettre  0 les flags de l'encodeur
		cbr		StatReg1,EXP2(FlagDecremente)

		mov		Work,MenuReg1						; On transfre le paramtre dans le bon regsitre

		call	SetContrast							;	- Oui
		rcall	AfficheBrightnessOrContrast			; et affiche la valeur
		rjmp	LoopLevelDispAdj0C					; Boucle Again

ExitAjusteDisplayCMenuNoSave:						; On se sauve sans sauver...

		sbis	PinSwitchMC,SwitchMC				; petit test habituel pour ne pas effectuer
		rjmp	ExitAjusteDisplayCMenuNoSave		; des sorties de menu en cascade

		call	ArreteClignotementLED				; Au cazo, on rallume la LED de On/StandBy

		ldi		ZH,RAM_Start						; Octet de poids fort de l'adresse de dbut en RAM 
		ldi		ZL,RAM_StartContrast				; L'adresse de ce paramtre en RAM
		ld		Work,Z							 	; Rcupre la valeur stocke en RAM
		call	SetContrast
		ret

ExitAjusteDisplayCMenu:
		sbis	PinMenu,SwitchMenu					; petit test habituel pour ne pas effectuer
		rjmp	ExitAjusteDisplayCMenu				; des sorties de menu en cascade

		call	ArreteClignotementLED				; Au cazo, on rallume la LED de On/StandBy

		ldi		Work,SaveLong						; Fixe le temps d'affichage du prochain message
		call	AfficheSaving						; Affiche le message de sauvegarde

		ldi		ZH,RAM_Start						; Octet de poids fort de l'adresse de dbut en RAM 
		ldi		ZL,RAM_StartContrast				; L'adresse de ce paramtre en RAM
		st		Z,MenuReg1							; et enregistre la valeur en RAM

		mov		Work2,MenuReg1						; La donne  enregistrer en EEPROM
		ldi		Work,EE_StartContrast				; et son adresse					
		call	WriteEEprom							; on enregistre
#endif
		ret											; et cassos


; ============================================================
; == Rglage de la luminosit Idle de l'afficheur           ==
; ==                                                        ==
; ==   - Encodeur -> Changer la valeur                      ==
; ==   - Menu     -> Valider la nouvelle valeur             ==
; ==   - StandBy  -> Remonter au menu prcdent sans sauver ==
; ============================================================

MenuAjusteDisplayI:

WaitMenuAjusteDisplayI:
		sbis	PinMenu,SwitchMenu					; Avant de passer  la suite,
		rjmp	WaitMenuAjusteDisplayI				; On attend le relachement du bouton de menu

; Bouton relch, on continue

		ldi		Work,0								; Se place au dbut
		call	DisplayPlaceCurseur

		ldi		ZH,HIGH(MenuDisplayIdleTopMessage*2)
		ldi		ZL,LOW(MenuDisplayIdleTopMessage*2)
		call	DisplayAfficheChaine

; On rcupre la valeur de la luminosit en RAM

		ldi		ZH,RAM_Start						; Octet de poids fort de l'adresse de dbut en RAM 
		ldi		ZL,RAM_IdleBrightness				; L'adresse de ce paramtre en RAM

		ld		MenuReg1,Z							; Rcupre la valeur stocke en RAM dans MenuReg1

		mov		Work,MenuReg1						; On va fixer la luminosit  cette valeur
		call	SetBrightness

		rcall	AfficheBrightnessOrContrast			; On affiche la valeur en seconde ligne

LoopLevelDispAdj0I:

		call 	LectureEncodeur						; Lecture de l'encodeur
		sbrs	StatReg1,FlagIncremente				; doit-on incrmenter
		sbrc	StatReg1,FlagDecremente				; ou dcrmenter ?
		rjmp	MenuChangeI							; l'un des deux...

		sbis	PinSwitchMC,SwitchMC				; Un appui sur le bouton d'annulation pour sortir sans sauver ?
		rjmp	ExitAjusteDisplayIMenuNoSave		; Oui, alors on y va

		sbic	PinMenu,SwitchMenu					; Un appui sur Menu ?
		rjmp 	LoopLevelDispAdj0I					; Non, on boucle

		rjmp	ExitAjusteDisplayIMenu				; sinon on se sauve en sauvant


MenuChangeI:

		sbrc	StatReg1,FlagIncremente				; regarde dans quel sens allait l'encodeur
		rjmp	IncIMenuReg1						; Vers le haut ?
		sbrc	StatReg1,FlagDecremente				; 
		rjmp	DecIMenuReg1						; vers le bas ?
		rjmp	LoopLevelDispAdj0I					; Aucun des deux, alors cassos

IncIMenuReg1:										; Incrmentation du paramtre
		mov		Work,MenuReg1
		cpi		Work,BrightnessMax					; c'est le max ?
		brne	DoIncIMR1							; non, alors on peut incrmenter sans pb

		rjmp	LoopLevelDispAdj0I					; Sinon, on ne fait rien

DoIncIMR1:
		inc		MenuReg1							; On incrmente le registre
		rjmp	MenuActualiseI						; et on modifie la luminosit

DecIMenuReg1:										; Dcrmentation de la luminosit
		mov		Work,MenuReg1						; transfert dans un registre immdiat
		cpi		Work,0								; c'est le min ?
		brne	DoDecIMR1							; non, alors on peut dcrmenter sans pb

		rjmp	LoopLevelDispAdj0I					; Sinon, on ne fait rien

DoDecIMR1:
		dec		MenuReg1							; On dcrmente le registre
		rjmp	MenuActualiseI						; et on modifie la luminosit

MenuActualiseI:										; On modifie vraiment la luminosit

		lds		Work,TCCR3B							; si le timer 3 ne tourne pas
		andi	Work,0b00000111						; on lance le clignotement de la LED On
		cpi		Work,0								; car on a modifi la valeur qui tait stocke
		brne	DoMenuActualiseI						
		call	LanceClignotementLED

DoMenuActualiseI:
		cbr		StatReg1,EXP2(FlagIncremente)		; On commence par remettre  0 les flags de l'encodeur
		cbr		StatReg1,EXP2(FlagDecremente)

		mov		Work,MenuReg1						; On transfre le paramtre dans le bon regsitre

		call	SetBrightness						; On rgle la loupiote
		rcall	AfficheBrightnessOrContrast			; et affiche la valeur
		rjmp	LoopLevelDispAdj0I

ExitAjusteDisplayIMenuNoSave:						; On se sauve sans sauver...

		sbis	PinSwitchMC,SwitchMC				; petit test habituel pour ne pas effectuer
		rjmp	ExitAjusteDisplayIMenuNoSave		; des sorties de menu en cascade

		call	ArreteClignotementLED				; Au cazo, on rallume la LED de On/StandBy

		ldi		ZH,RAM_Start						; Octet de poids fort de l'adresse de dbut en RAM 
		ldi		ZL,RAM_StartBrightness				; L'adresse de ce paramtre en RAM
		ld		Work,Z							 	; Rcupre la valeur stocke en RAM
		call	SetBrightness

		ret

ExitAjusteDisplayIMenu:
		sbis	PinMenu,SwitchMenu					; petit test habituel pour ne pas effectuer
		rjmp	ExitAjusteDisplayIMenu				; des sorties de menu en cascade

		call	ArreteClignotementLED				; Au cazo, on rallume la LED de On/StandBy

		ldi		Work,SaveLong						; Fixe le temps d'affichage du prochain message
		call	AfficheSaving						; Affiche le message de sauvegarde

		ldi		ZH,RAM_Start						; Octet de poids fort de l'adresse de dbut en RAM 
		ldi		ZL,RAM_IdleBrightness				; L'adresse de ce paramtre en RAM
		st		Z,MenuReg1							; et enregistre la valeur en RAM

		mov		Work2,MenuReg1						; La donne  enregistrer en EEPROM
		ldi		Work,EE_IdleBrightness				; et son adresse					
		call	WriteEEprom							; on enregistre

; -- On n'oublie pas de restaurer la luminosit de dpart
		ldi		ZH,RAM_Start						; Octet de poids fort de l'adresse de dbut en RAM 
		ldi		ZL,RAM_StartBrightness				; L'adresse de ce paramtre en RAM
		ld		Work,Z
		call	SetBrightness						; et c'est fini

		ret

; ============================================================
; == Rglage de dure avant passage en mode Idle            ==
; ==                                                        ==
; ==   - Encodeur -> Changer la valeur                      ==
; ==   - Menu     -> Valider la nouvelle valeur             ==
; ==   - StandBy  -> Remonter au menu prcdent sans sauver ==
; ============================================================

MenuAjusteDisplayT:

WaitMenuAjusteDisplayT:
		sbis	PinMenu,SwitchMenu					; Avant de passer  la suite,
		rjmp	WaitMenuAjusteDisplayT				; On attend le relachement du bouton de menu

; Bouton relch, on continue

		ldi		Work,0								; Se place au dbut
		call	DisplayPlaceCurseur

		ldi		ZH,HIGH(MenuDisplayIdleTimeOutTopMessage*2)
		ldi		ZL,LOW(MenuDisplayIdleTimeOutTopMessage*2)
		call	DisplayAfficheChaine

; On rcupre la valeur de la dure en RAM

		ldi		ZH,RAM_Start						; Octet de poids fort de l'adresse de dbut en RAM 
		ldi		ZL,RAM_IdleTimeOut					; L'adresse de ce paramtre en RAM

		ld		MenuReg1,Z							; Rcupre la valeur stocke en RAM dans MenuReg1

		rcall	AfficheIdleTimeOut					; En seconde ligne

LoopLevelDispAdj0T:

		call 	LectureEncodeur						; Lecture de l'encodeur
		sbrs	StatReg1,FlagIncremente				; doit-on incrmenter
		sbrc	StatReg1,FlagDecremente				; ou dcrmenter ?
		rjmp	MenuChangeT							; l'un des deux...

		sbis	PinSwitchMC,SwitchMC				; Un appui sur le bouton d'annulation pour sortir sans sauver ?
		rjmp	ExitAjusteDisplayTMenuNoSave		; Oui, alors on y va

		sbic	PinMenu,SwitchMenu					; Un appui sur Menu ?
		rjmp 	LoopLevelDispAdj0T					; Non, on boucle

		rjmp	ExitAjusteDisplayTMenu				; sinon on se sauve en sauvant

MenuChangeT:

		sbrc	StatReg1,FlagIncremente				; regarde dans quel sens allait l'encodeur
		rjmp	IncTMenuReg1						; Vers le haut ?
		sbrc	StatReg1,FlagDecremente				; 
		rjmp	DecTMenuReg1						; vers le bas ?
		rjmp	LoopLevelDispAdj0T					; Aucun des deux, alors cassos

IncTMenuReg1:										; Incrmentation du paramtre
		mov		Work,MenuReg1
		cpi		Work,241							; c'est le max ?
		brlo	DoIncTMR1							; non, alors on peut incrmenter sans pb

		rjmp	LoopLevelDispAdj0T					; Sinon, on ne fait rien

DoIncTMR1:
		cpi		Work,0								; Dsactiv
	    breq	LoopLevelDispAdj0T					; on n'incrmente pas

		cpi		Work,240							; 1 heure ?
		breq	TOHtoOff							; On passe  0 pour "Never"
		cpi		Work,1								; 15 secondes ?
		breq	TO15To30							; on passe  30 s
		cpi		Work,2								; 30 secondes ?
		breq	TO30To1								; on passe  1 min
		cpi		Work,4								; 1 minute ?
		breq	TO1To2								; on passe  2 min
		cpi		Work,8								; 2 minutes ?
		breq	TO2To5								; on passe  5 min

		subi	Work,-20							; On ajoute 5 minutes...
		mov		MenuReg1,Work						; Et on remet a dans le bon registre
		rjmp	MenuActualiseT						; et on modifie la dure
TOHToOff:
		ldi		Work,0								; Valeur pour dsactiver le TimeOut
		mov		MenuReg1,Work						; Et on remet a dans le bon registre
		rjmp	MenuActualiseT						; et on modifie la dure

TO15To30:
		ldi		Work,2								; Valeur pour 30 secondes
		mov		MenuReg1,Work						; Et on remet a dans le bon registre
		rjmp	MenuActualiseT						; et on modifie la dure

TO30To1:
		ldi		Work,4								; Valeur pour 1 minute
		mov		MenuReg1,Work						; Et on remet a dans le bon registre
		rjmp	MenuActualiseT						; et on modifie la dure

TO1To2:
		ldi		Work,8								; Valeur pour 2 minutes
		mov		MenuReg1,Work						; Et on remet a dans le bon registre
		rjmp	MenuActualiseT						; et on modifie la dure

TO2To5:
		ldi		Work,20								; Valeur pour 5 minutes
		mov		MenuReg1,Work						; Et on remet a dans le bon registre
		rjmp	MenuActualiseT						; et on modifie la dure

DecTMenuReg1:										; Dcrmentation de la luminosit
		mov		Work,MenuReg1						; transfert dans un registre immdiat
		cpi		Work,1								; c'est le min ?
		brne	DoDecTMR1							; non, alors on peut dcrmenter sans pb

		rjmp	LoopLevelDispAdj0T					; Sinon, on ne fait rien

DoDecTMR1:
		cpi		Work,0								; Dsactiv
		breq	TOOffToH							; On passe  1 Heure
		cpi		Work,2								; 30 secondes ?
		breq	TO30To15							; On passe  15 secondes
		cpi		Work,4								; 1 minute ?
		breq	TO1To30								; On passe  30 secondes
		cpi		Work,8								; 2 minutes ?
		breq	TO2To1								; On passe  1 minute
		cpi		Work,20								; 5 minutes ?
		breq	TO5To2								; On passe  2 minutes

		subi	Work,20								; 5 minutes de moins...
		mov		MenuReg1,Work						; Et on remet a dans le bon registre
		rjmp	MenuActualiseT						; et on modifier la dure
TOOffToH:
		ldi		Work,240							; Valeur pour 1 Heure
		mov		MenuReg1,Work						; Et on remet a dans le bon registre
		rjmp	MenuActualiseT						; et on modifier la dure

TO30To15:
		ldi		Work,1								; Valeur pour 30 secondes
		mov		MenuReg1,Work						; Et on remet a dans le bon registre
		rjmp	MenuActualiseT						; et on modifier la dure

TO1To30:
		ldi		Work,2								; Valeur pour 30 secondes
		mov		MenuReg1,Work						; Et on remet a dans le bon registre
		rjmp	MenuActualiseT						; et on modifier la dure

TO2To1:
		ldi		Work,4								; Valeur pour 1 Minute
		mov		MenuReg1,Work						; Et on remet a dans le bon registre
		rjmp	MenuActualiseT						; et on modifier la dure

TO5To2:
		ldi		Work,8								; Valeur pour 2 minutes
		mov		MenuReg1,Work						; Et on remet a dans le bon registre
		rjmp	MenuActualiseT						; et on modifier la dure

MenuActualiseT:										; On modifie vraiment la dure

		lds		Work,TCCR3B							; si le timer 3 ne tourne pas
		andi	Work,0b00000111						; on lance le clignotement de la LED On
		cpi		Work,0								; car on a modifi la valeur qui tait stocke
		brne	DoMenuActualiseT						
		call	LanceClignotementLED

DoMenuActualiseT:
		cbr		StatReg1,EXP2(FlagIncremente)		; On commence par remettre  0 les flags de l'encodeur
		cbr		StatReg1,EXP2(FlagDecremente)

		mov		Work,MenuReg1						; On transfre le paramtre dans le bon regsitre

		rcall	AfficheIdleTimeOut					; et affiche la valeur
		rjmp	LoopLevelDispAdj0T					; Boucle Again

ExitAjusteDisplayTMenuNoSave:						; On se sauve sans sauver...

		sbis	PinSwitchMC,SwitchMC				; petit test habituel pour ne pas effectuer
		rjmp	ExitAjusteDisplayTMenuNoSave		; des sorties de menu en cascade

		call	ArreteClignotementLED				; Au cazo, on rallume la LED de On/StandBy

		ldi		ZH,RAM_Start						; Octet de poids fort de l'adresse de dbut en RAM 
		ldi		ZL,RAM_IdleTimeOut					; L'adresse de ce paramtre en RAM
		ld		Work,Z							 	; Rcupre la valeur stocke en RAM
		ret

ExitAjusteDisplayTMenu:
		sbis	PinMenu,SwitchMenu					; petit test habituel pour ne pas effectuer
		rjmp	ExitAjusteDisplayTMenu				; des sorties de menu en cascade

		call	ArreteClignotementLED				; Au cazo, on rallume la LED de On/StandBy

		ldi		Work,SaveLong						; Fixe le temps d'affichage du prochain message
		call	AfficheSaving						; Affiche le message de sauvegarde

		ldi		ZH,RAM_Start						; Octet de poids fort de l'adresse de dbut en RAM 
		ldi		ZL,RAM_IdleTimeOut					; L'adresse de ce paramtre en RAM
		st		Z,MenuReg1							; et enregistre la valeur en RAM

		mov		Work2,MenuReg1						; La donne  enregistrer en EEPROM
		ldi		Work,EE_IdleTimeOut					; et son adresse					
		call	WriteEEprom							; on enregistre

		ret											; et cassos

; ============================================================
; == Extinction ou non de la led "on" en mode Idle          ==
; ==                                                        ==
; ==   - Encodeur -> Choisir Yes/No 	                    ==
; ==   - Menu     -> Valider la nouvelle valeur             ==
; ==   - StandBy  -> Remonter au menu prcdent sans sauver ==
; ============================================================

MenuAjusteDisplayL:

WaitMenuAjusteDisplayL:
		sbis	PinMenu,SwitchMenu					; Avant de passer  la suite,
		rjmp	WaitMenuAjusteDisplayL				; On attend le relachement du bouton de menu

; Bouton relch, on continue

		ldi		Work,0								; Se place au dbut
		call	DisplayPlaceCurseur

		ldi		ZH,HIGH(MenuDisplayIdleLedTopMessage*2)
		ldi		ZL,LOW(MenuDisplayIdleLedTopMessage*2)
		call	DisplayAfficheChaine

; On rcupre la valeur de la luminosit en RAM

		ldi		ZH,RAM_Start						; Octet de poids fort de l'adresse de dbut en RAM 
		ldi		ZL,RAM_IdleLed						; L'adresse de ce paramtre en RAM

		ld		MenuReg1,Z							; Rcupre la valeur stocke en RAM dans MenuReg1

		rcall	AfficheIdleLed						; On affiche la valeur en seconde ligne

LoopLevelDispAdj0L:

		call 	LectureEncodeur						; Lecture de l'encodeur
		sbrs	StatReg1,FlagIncremente				; doit-on incrmenter
		sbrc	StatReg1,FlagDecremente				; ou dcrmenter ?
		rjmp	MenuChangeL							; l'un des deux...

		sbis	PinSwitchMC,SwitchMC				; Un appui sur le bouton d'annulation pour sortir sans sauver ?
		rjmp	ExitAjusteDisplayLMenuNoSave		; Oui, alors on y va

		sbic	PinMenu,SwitchMenu					; Un appui sur Menu ?
		rjmp 	LoopLevelDispAdj0L					; Non, on boucle

		rjmp	ExitAjusteDisplayLMenu				; sinon on se sauve en sauvant

MenuChangeL:

		sbrc	StatReg1,FlagIncremente				; regarde dans quel sens allait l'encodeur
		rjmp	ChangeLMenuReg1						; Vers le haut ?
		sbrc	StatReg1,FlagDecremente				; 
		rjmp	ChangeLMenuReg1						; vers le bas ?
		rjmp	LoopLevelDispAdj0L					; Aucun des deux, alors cassos

ChangeLMenuReg1:									; Juste  transformer les 0 en 1 ou 1 en 0 

		inc		MenuReg1							; on ajoute 1
		ldi		Work,0b00000001
		and		MenuReg1,Work						; et on met  zro tous les bits, sauf le premier

		lds		Work,TCCR3B							; si le timer 3 ne tourne pas
		andi	Work,0b00000111						; on lance le clignotement de la LED On
		cpi		Work,0								; car on a modifi la valeur qui tait stocke
		brne	DoMenuActualiseL						
		call	LanceClignotementLED

DoMenuActualiseL:
		cbr		StatReg1,EXP2(FlagIncremente)		; On commence par remettre  0 les flags de l'encodeur
		cbr		StatReg1,EXP2(FlagDecremente)

		rcall	AfficheIdleLed						; et affiche la valeur
		rjmp	LoopLevelDispAdj0L

ExitAjusteDisplayLMenuNoSave:						; On se sauve sans sauver...

		sbis	PinSwitchMC,SwitchMC				; petit test habituel pour ne pas effectuer
		rjmp	ExitAjusteDisplayLMenuNoSave		; des sorties de menu en cascade

		call	ArreteClignotementLED				; Au cazo, on rallume la LED de On/StandBy

		ret

ExitAjusteDisplayLMenu:
		sbis	PinMenu,SwitchMenu					; petit test habituel pour ne pas effectuer
		rjmp	ExitAjusteDisplayLMenu				; des sorties de menu en cascade

		call	ArreteClignotementLED				; Au cazo, on rallume la LED de On/StandBy

		ldi		Work,SaveLong						; Fixe le temps d'affichage du prochain message
		call	AfficheSaving						; Affiche le message de sauvegarde

		ldi		ZH,RAM_Start						; Octet de poids fort de l'adresse de dbut en RAM 
		ldi		ZL,RAM_IdleLed						; L'adresse de ce paramtre en RAM
		st		Z,MenuReg1							; et enregistre la valeur en RAM

		mov		Work2,MenuReg1						; La donne  enregistrer en EEPROM
		ldi		Work,EE_IdleLed						; et son adresse					
		call	WriteEEprom							; on enregistre

		ret

; =============================================================
; == Affichage de la valeur de la luminosit ou du contraste ==
; == Cette valeur est contenue dans MenuReg1                 ==
; =============================================================

AfficheBrightnessOrContrast:

		ldi		Work,0x40							; Dbut de seconde ligne
		call	DisplayPlaceCurseur
		ldi		ZH,HIGH(MenuDisplayValueMessage*2)
		ldi		ZL,LOW(MenuDisplayValueMessage*2)
		call	DisplayAfficheChaine
		call	DisplayArrow

		ldi		Work,0x4A							; Curseur au bon endroit
		call	DisplayPlaceCurseur

		mov		Work1,MenuReg1						; Dans un registre immdiat

		call 	Affiche255							; et on affiche la valeur

		ldi		Char,32								; et deux blancs pour ventuellement effacer le reste
		call	DisplayWriteChar
		call	DisplayWriteChar

		ret											; et voil

; =================================================
; == Affiche le trigger pour l'entre considre ==
; == Le numro de l'entre est dans MenuReg1     ==
; =================================================

AfficheIdleLed:

		ldi		Work,0x40							; Dbut de seconde ligne
		call	DisplayPlaceCurseur

		mov		Work2,MenuReg1
		cpi		Work2,0								; Eteindre la Led ?
		brne	MenuIdleLedEcrireOff				; 	- Oui (Valeur > 0)

		ldi		ZH,HIGH(MenuIdleLedOnMessage*2)
		ldi		ZL,LOW(MenuIdleLedOnMessage*2)
		call	DisplayAfficheChaine
		call	DisplayArrow

		ret											; vouala

MenuIdleLedEcrireOff:
		ldi		ZH,HIGH(MenuIdleLedOffMessage*2)
		ldi		ZL,LOW(MenuIdleLedOffMessage*2)
		call	DisplayAfficheChaine
		call	DisplayArrow

		ret											; cfini

; =============================================================
; == Affichage de la valeur de la luminosit ou du contraste ==
; == Cette valeur est contenue dans MenuReg1                 ==
; =============================================================

AfficheIdleTimeOut:

		ldi		Work,0x40							; Dbut de seconde ligne
		call	DisplayPlaceCurseur
		ldi		ZH,HIGH(MenuDisplayTOValueMessage*2)
		ldi		ZL,LOW(MenuDisplayTOValueMessage*2)
		call	DisplayAfficheChaine
		call	DisplayArrow

		mov		Work1,MenuReg1						; Dans un registre immdiat

		cpi		Work1,0								; Pour '0', on affiche "Never"							
		breq	TimeOutNever

		cpi		Work1,240							; pour 240, afficher '1 hour'
		breq	TimeOutOneHour

		cpi		Work1,5								; Moins de 2 minutes 
		brlo	TimeOutOneOrLess

		ldi		Work,0x45							; Curseur en position pour les dizaines de minutes
		cpi		Work1,40							; c'est bien plus de 5 minutes ?
		brsh	TimeOutLocCursor					; Vi alors Go

		ldi		Work,0x46							; Sinon curseur pour les units

TimeOutLocCursor:
		call	DisplayPlaceCurseur

; Comme "l'unit" est de 15 secondes, on divise la valeur par 4 pour avoir le temps en minutes...

		lsr		Work1								; Divise par 2
		lsr		Work1								; Et encore par deux

		mov		LSDVol,Work1						; on transfre dans le registre de 'conversion'
		call	BinaireToBCD						; et on convertit en dcimal

		ldi		Work,48								; Y-a-t-il un 0 au dbut (48 en Ascii)
		cp		Work,MSDVol						
		breq	TimeOutAffUnits						; Oui -> On n'affiche que les units
		
		mov		Char,MSDVol							; Sinon, on affiche le chiffre
		call	DisplayWriteChar

TimeOutAffUnits:									; On affiche les units des minutes...
		mov		Char,LSDVol
		call	DisplayWriteChar						
		call	AfficheToMinutes		
		ret											; et oual

TimeOutNever:										; On crit "Off"
		ldi		Work,0x48
		call	DisplayPlaceCurseur
		call	AfficheToNever
		ret	

TimeOutOneHour:										; On crit '1 hour'
		ldi		Work,0x47
		call	DisplayPlaceCurseur
		ldi 	Char,'1'
		call	DisplayWriteChar
		ldi 	Char,32
		call	DisplayWriteChar
		ldi 	Char,'H'
		call	DisplayWriteChar
		ldi 	Char,'o'
		call	DisplayWriteChar
		ldi 	Char,'u'
		call	DisplayWriteChar
		ldi 	Char,'r'
		call	DisplayWriteChar
		
		ret
			
TimeOutOneOrLess:
		ldi		Work,0x46
		call	DisplayPlaceCurseur

		cpi		Work1,4								; Une minute ?
		brne	TimeOut30Seconds

		ldi		Char,'1'							; Et on affiche 'Minute'
		call	DisplayWriteChar
		ldi		Char,32
		call	DisplayWriteChar						
		ldi		Char,'M'							
		call	DisplayWriteChar						
		ldi		Char,'i'
		call	DisplayWriteChar						
		ldi		Char,'n'
		call	DisplayWriteChar						
		ldi		Char,'u'
		call	DisplayWriteChar						
		ldi		Char,'t'
		call	DisplayWriteChar						
		ldi		Char,'e'
		call	DisplayWriteChar						

		ret

TimeOut30Seconds:									; On affiche "30 Seconds"

		ldi		Work,0x45
		call	DisplayPlaceCurseur
		
		cpi		Work1,2								; 15 Secondes ?
		brne	TimeOut15Seconds

		ldi		Char,'3'
		call	DisplayWriteChar
		ldi		Char,'0'
		call	DisplayWriteChar
		ldi		Char,32
		call	DisplayWriteChar						
		ldi		Char,'S'							
		call	DisplayWriteChar						
		ldi		Char,'e'
		call	DisplayWriteChar						
		ldi		Char,'c'
		call	DisplayWriteChar						
		ldi		Char,'o'
		call	DisplayWriteChar						
		ldi		Char,'n'
		call	DisplayWriteChar						
		ldi		Char,'d'
		call	DisplayWriteChar						
		ldi		Char,'s'
		call	DisplayWriteChar						

		ret

TimeOut15Seconds:									; On affiche "15 Seconds"

		ldi		Work,0x45
		call	DisplayPlaceCurseur
		
		ldi		Char,'1'
		call	DisplayWriteChar
		ldi		Char,'5'
		call	DisplayWriteChar
		ldi		Char,32
		call	DisplayWriteChar						
		ldi		Char,'S'							
		call	DisplayWriteChar						
		ldi		Char,'e'
		call	DisplayWriteChar						
		ldi		Char,'c'
		call	DisplayWriteChar						
		ldi		Char,'o'
		call	DisplayWriteChar						
		ldi		Char,'n'
		call	DisplayWriteChar						
		ldi		Char,'d'
		call	DisplayWriteChar						
		ldi		Char,'s'
		call	DisplayWriteChar						

		ret

AfficheTOMinutes:
		ldi		Char,32
		call	DisplayWriteChar						
		ldi		Char,'M'							; Et on affiche 'Minutes'
		call	DisplayWriteChar						
		ldi		Char,'i'
		call	DisplayWriteChar						
		ldi		Char,'n'
		call	DisplayWriteChar						
		ldi		Char,'u'
		call	DisplayWriteChar						
		ldi		Char,'t'
		call	DisplayWriteChar						
		ldi		Char,'e'
		call	DisplayWriteChar						
		ldi		Char,'s'
		call	DisplayWriteChar						
				 
		ret

AfficheToNever:										; "Never" pour le time out dsactiv
		ldi		Char,'N'
		call	DisplayWriteChar						
		ldi		Char,'e'
		call	DisplayWriteChar						
		ldi		Char,'v'
		call	DisplayWriteChar						
		ldi		Char,'e'
		call	DisplayWriteChar						
		ldi		Char,'r'
		call	DisplayWriteChar						

		ret
